clear all;close all;clc
data_dir=[pwd filesep];

fid=fopen([data_dir 'ALARMS'],'r');
if(fid ~= -1)
    RECLIST=textscan(fid,'%s %s %d','Delimiter',',');
    fclose(fid);
else
    error('Could not open ALARMS.txt for scoring. Exiting...')
end

RECORDS=RECLIST{1};
ALARMS=RECLIST{2};
GOLD=RECLIST{3};

max_num = 4;

matrix  = zeros(5751,750*max_num);
desc    = cell(1,750*max_num);
classes = cell(1,750*max_num);
alarms  = zeros(1,750*max_num);
sig_start = (125*60*5)-125*16;

for i=1:length(RECORDS)
    disp(i)
    alarm=GOLD(i);
    class=ALARMS(i);
    recName=RECORDS(i);
    [~,signal,Fs,siginfo]=rdmat(char(recName));
    description=squeeze(struct2cell(siginfo));
    description=description(4,:);
    
    Fs=Fs(1);
    if Fs~=125
        signal=resample(signal,125,Fs);
    end
    signal = signal(sig_start:end,:);  
    
    index = (i-1)*max_num;
    lng   = length(signal);
    for n=1:length(description)
        sig_0 = signal(:,n);
        matrix(1:lng,index+n)=sig_0;
        desc(index+n)=cellstr(description(n));
        alarms(index+n)=alarm;
        classes(index+n)=class;
    end
end

csvwrite('data.csv',matrix);

meta = [classes; desc];

fid = fopen('metadata.csv','wt');
 if fid>0
     for k=1:length(meta)
         fprintf(fid,'%s,%s\n',meta{:,k});
     end
     fclose(fid);
 end
 
 csvwrite('alarms.csv',alarms);